#! /bin/bash

echo "Mixes N MonoFiles live to any"
echo "desired number of output channels."
echo "Please enter"
echo "1) number of output device (usual 0)"
echo "2) number of output channels"
echo "3) audio files as input"

read -e AUDIODEV NOUTCHNLS DATS

echo
echo "Number of audio device = $AUDIODEV"
echo "Number of output channels = $NOUTCHNLS" 
echo "Files =" 
SDATS=""
for dat in $DATS ; do
echo $dat
SDATS=$SDATS","$dat; done; SDATS=\"${SDATS#,}\"
echo 

cat<<EOF>/tmp/play.csd
<CsoundSynthesizer>
<CsOptions>
-odac$AUDIODEV -+max_str_len=10000 -b 1024 -B 4096
</CsOptions>
<CsInstruments>

sr = 44100
ksmps = 256
nchnls = $NOUTCHNLS
0dbfs = 1

			FLpanel	"Mixdown Player", 400, 200, 200, 200
gkdb, idisp_db 	FLslider 	"Volume", -18, 6, 0, 23, -1, 300, 30, 25, 25
			FLsetVal_i 	0, idisp_db
gidb			FLvalue	"db", 30, 30, 340, 25
kstart, idisp_strt	FLbutton 	"@>", 0, 0, 1, 60, 30, 30, 125, 105, 1, 0, -1
kpause, idisp_paus	FLbutton 	"@||", 0, 0, 1, 60, 30, 100, 125, 105, 777, 0, -1
kstop, idisp_stop	FLbutton 	"@square", 0, 0, 1, 60, 30, 170, 125, 105, 888, 0, .1
gkskip, iui 		FLslider 	"Skiptime", 0, 1, 0, 23, -1, 250, 30, 25, 75
giskipmin		FLvalue	"min", 30, 30, 300, 75
giskipsec		FLvalue	"sec", 30, 30, 340, 75
gipposmin		FLvalue	"min", 30, 30, 250, 125
gippossec		FLvalue	"sec", 30, 30, 290, 125
kquit, idisp_quit 	FLbutton 	"Quit", 0, 0, 1, 30, 30, 340, 125, 105, 999, 0, .1
    			FLsetColor	255, 100, 0, idisp_quit
			FLpanelEnd
			FLrun

giwarpaus		init		0
giplaypos		init		0

  opcode StrayGetEl, ii, Sijj
;returns the startindex and the endindex (= the first space after the element) for ielindex in String. if startindex returns -1, the element has not been found
Stray, ielindx, isepA, isepB xin
;;DEFINE THE SEPERATORS
isep1		=		(isepA == -1 ? 32 : isepA)
isep2		=		(isepA == -1 && isepB == -1 ? 9 : (isepB == -1 ? isep1 : isepB))
Sep1		sprintf	"%c", isep1
Sep2		sprintf	"%c", isep2
;;INITIALIZE SOME PARAMETERS
ilen		strlen		Stray
istartsel	=		-1; startindex for searched element
iendsel	=		-1; endindex for searched element
iel		=		0; actual number of element while searching
iwarleer	=		1
indx		=		0
 if ilen == 0 igoto end ;don't go into the loop if Stray is empty
loop:
Snext		strsub		Stray, indx, indx+1; next sign
isep1p		strcmp		Snext, Sep1; returns 0 if Snext is sep1
isep2p		strcmp		Snext, Sep2; 0 if Snext is sep2
;;NEXT SIGN IS NOT SEP1 NOR SEP2
if isep1p != 0 && isep2p != 0 then
 if iwarleer == 1 then; first character after a seperator 
  if iel == ielindx then; if searched element index
istartsel	=		indx; set it
iwarleer	=		0
  else 			;if not searched element index
iel		=		iel+1; increase it
iwarleer	=		0; log that it's not a seperator 
  endif 
 endif 
;;NEXT SIGN IS SEP1 OR SEP2
else 
 if istartsel > -1 then; if this is first selector after searched element
iendsel	=		indx; set iendsel
		igoto		end ;break
 else	
iwarleer	=		1
 endif 
endif
		loop_lt	indx, 1, ilen, loop 
end: 		xout		istartsel, iendsel
  endop 

  opcode StrayLen, i, Sjj
;returns the number of elements in Stray. elements are defined by two seperators as ASCII coded characters: isep1 defaults to 32 (= space), isep2 defaults to 9 (= tab). if just one seperator is used, isep2 equals isep1
Stray, isepA, isepB xin
;;DEFINE THE SEPERATORS
isep1		=		(isepA == -1 ? 32 : isepA)
isep2		=		(isepA == -1 && isepB == -1 ? 9 : (isepB == -1 ? isep1 : isepB))
Sep1		sprintf	"%c", isep1
Sep2		sprintf	"%c", isep2
;;INITIALIZE SOME PARAMETERS
ilen		strlen		Stray
icount		=		0; number of elements
iwarsep	=		1
indx		=		0
 if ilen == 0 igoto end ;don't go into the loop if String is empty
loop:
Snext		strsub		Stray, indx, indx+1; next sign
isep1p		strcmp		Snext, Sep1; returns 0 if Snext is sep1
isep2p		strcmp		Snext, Sep2; 0 if Snext is sep2
 if isep1p == 0 || isep2p == 0 then; if sep1 or sep2
iwarsep	=		1; tell the log so
 else 				; if not 
  if iwarsep == 1 then	; and has been sep1 or sep2 before
icount		=		icount + 1; increase counter
iwarsep	=		0; and tell you are ot sep1 nor sep2 
  endif 
 endif	
		loop_lt	indx, 1, ilen, loop 
end: 		xout		icount
  endop 

  opcode MxdwnPlay, 0, Siiiki
Stray, ilen, ichnls, iel, kvol, iskip xin
ipan 		=		iel * ((ichnls-1)/(ilen-1))
ioutch1	=		int(ipan) + 1
ipan2		=		frac(ipan)
ist, ien	StrayGetEl	Stray, iel, 44
Sel		strsub		Stray, ist, ien
asig		soundin	Sel, iskip
iscale		=		ichnls / ilen
a1, a2		pan2		asig*iscale*kvol, ipan2
		outch		ioutch1, a1
if ipan != 0 then; nicht mehr kanäle schreiben als da sind
		outch		ioutch1 + 1, a2
endif
if iel < ilen-1 then
		MxdwnPlay 	Stray, ilen, ichnls, iel+1, kvol, iskip
endif
  endop


instr 1; play
Stray = $SDATS
ist, ien	StrayGetEl	Stray, 0, 44; dauer vom ersten element holen
Sfirst		strsub		Stray, ist, ien
idur		filelen	Sfirst
ilen		StrayLen	Stray, 44
ichnls		=		nchnls
 if giwarpaus == 1 then; if pause button has been pressed
kskip		=		giplaypos
 else	
kskip		=		gkskip*idur; wirkliche skiptime
 endif	
kvol		=		ampdb(gkdb)
kskipmin	=		floor(kskip/60)
kskipsec	=		floor(kskip%60)
		FLprintk2	kskipmin, giskipmin
		FLprintk2	kskipsec, giskipsec
		FLprintk2	gkdb, gidb
knewskip	changed	kskip
if knewskip == 1 then
		reinit		skip
endif
skip:
iskip 		=		i(kskip)
		event_i	"i", -2, 0, -1, iskip, idur; terminate i2
		event_i	"i", 2, 0, -1, iskip, idur; call with new skip
		MxdwnPlay	Stray, ilen, ichnls, 0, kvol, iskip
giwarpaus	=		0
endin

instr 2; display
ktim		timeinsts
gkplaypos	=		p4 + ktim
kpposmin	=		floor(gkplaypos/60)
		FLprintk2	kpposmin, gipposmin
kppossec	=		floor(gkplaypos%60)
		FLprintk2	kppossec, gippossec
if gkplaypos > p5 then; if file has finished
		event		"i", -1, 0, -1; terminate i1
		turnoff	; go to sleep
endif 
endin

instr 777; pause button
		event_i	"i", -1, 0, -1; terminate i1
		event_i	"i", -2, 0, -1; terminate i2
giwarpaus	=		1
giplaypos	=		i(gkplaypos)
endin

instr 888; stop button
		event_i	"i", -1, 0, -1; terminate i1
		event_i	"i", -2, 0, -1; terminate i2
giwarpaus	=		0
endin

instr 999; quit button
exitnow
endin

</CsInstruments>
<CsScore>
f 0 36000
e
</CsScore>
</CsoundSynthesizer>

EOF

csound /tmp/play.csd

